/*
 * @(#)53    1.1  src/pdwebrte/azn/eaidemo/EAIDemo/JavaSource/com/tivoli/am/eb/web/eaidemo/EAIConfigServlet.java, pdweb.ws.authn.eai, amwebrte611  8/20/04  16:50:06
 * ===========================================================================
 * Licensed Materials - Property of IBM
 *
 * (C) Copyright IBM Corp. 2004 All Rights Reserved.
 * ===========================================================================
 *
 */
package com.tivoli.am.eb.web.eaidemo;


import java.io.IOException;

import java.util.Enumeration;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * A servlet that responds to the configuration form, and sets appropriate
 * configuration values.
 *
 * @author Tivoli Systems
 */
public class EAIConfigServlet extends HttpServlet implements Servlet {
    private EAIDemoServerConfig config = null;


    /**
     * Gets the server config file out of the application context.
     */
    public void init() throws ServletException {
        super.init();

        config = EAIDemoServerConfig.getInstance(this.getServletContext());
    }


    /**
     * Processes the information provided in a GET request to this servlet.
     * All key-value pairs are stored back into a properties file for use
     * by the other servlets. 
     */
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
                  throws ServletException, IOException
    {
        setProperties(req);
    }


    /**
     * Processes the information provided in a POST request to this servlet.
     * All key-value pairs are stored back into a properties file for use
     * by the other servlets. 
     */
    protected void doPost(HttpServletRequest req, HttpServletResponse resp)
                   throws ServletException, IOException
    {
        setProperties(req);
    }


    /**
     * For each item submitted in the request to this servelet, set the
     * appropriate configuration value.
     *
     * @param req the http request.
     */
    private void setProperties(HttpServletRequest req) {
        // get the form data and set the config values
        Enumeration e = req.getParameterNames();

        while(e.hasMoreElements()) {
            String name = (String)e.nextElement();
            String value = req.getParameter(name);

            config.getConfig().setProperty(name, value);
        }

        config.storeConfig();
    }
}
